#include "common.h"
#include "reduce_scatter.h"
DEFINE_ncclDevFunc(ReduceScatter_RING_LL_MinMax_bf16_0_0_1, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_RING, NCCL_PROTO_LL, 0, 0, 1)
#if (defined(__gfx90a__) || defined(__gfx942__) || defined(__gfx950__)) && defined(ENABLE_LL128)
DEFINE_ncclDevFunc(ReduceScatter_RING_LL128_MinMax_bf16_0_0_1, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_RING, NCCL_PROTO_LL128, 0, 0, 1)
#endif
DEFINE_ncclDevFunc(ReduceScatter_RING_SIMPLE_MinMax_bf16_0_0_1, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_RING, NCCL_PROTO_SIMPLE, 0, 0, 1)
DEFINE_ncclDevFunc(ReduceScatter_RING_SIMPLE_MinMax_bf16_0_1_1, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_RING, NCCL_PROTO_SIMPLE, 0, 1, 1)
DEFINE_ncclDevFunc(ReduceScatter_PAT_LL_MinMax_bf16_0_0_1, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_PAT, NCCL_PROTO_LL, 0, 0, 1)
#if (defined(__gfx90a__) || defined(__gfx942__) || defined(__gfx950__)) && defined(ENABLE_LL128)
DEFINE_ncclDevFunc(ReduceScatter_PAT_LL128_MinMax_bf16_0_0_1, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_PAT, NCCL_PROTO_LL128, 0, 0, 1)
#endif
DEFINE_ncclDevFunc(ReduceScatter_PAT_SIMPLE_MinMax_bf16_0_0_1, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_PAT, NCCL_PROTO_SIMPLE, 0, 0, 1)
DEFINE_ncclDevFunc(ReduceScatter_PAT_SIMPLE_MinMax_bf16_0_1_1, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_PAT, NCCL_PROTO_SIMPLE, 0, 1, 1)
DEFINE_ncclDevFunc(ReduceScatter_RING_LL_MinMax_bf16_0_0_2, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_RING, NCCL_PROTO_LL, 0, 0, 2)
#if (defined(__gfx90a__) || defined(__gfx942__) || defined(__gfx950__)) && defined(ENABLE_LL128)
DEFINE_ncclDevFunc(ReduceScatter_RING_LL128_MinMax_bf16_0_0_2, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_RING, NCCL_PROTO_LL128, 0, 0, 2)
#endif
DEFINE_ncclDevFunc(ReduceScatter_RING_SIMPLE_MinMax_bf16_0_0_2, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_RING, NCCL_PROTO_SIMPLE, 0, 0, 2)
DEFINE_ncclDevFunc(ReduceScatter_RING_SIMPLE_MinMax_bf16_0_1_2, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_RING, NCCL_PROTO_SIMPLE, 0, 1, 2)
DEFINE_ncclDevFunc(ReduceScatter_PAT_LL_MinMax_bf16_0_0_2, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_PAT, NCCL_PROTO_LL, 0, 0, 2)
#if (defined(__gfx90a__) || defined(__gfx942__) || defined(__gfx950__)) && defined(ENABLE_LL128)
DEFINE_ncclDevFunc(ReduceScatter_PAT_LL128_MinMax_bf16_0_0_2, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_PAT, NCCL_PROTO_LL128, 0, 0, 2)
#endif
DEFINE_ncclDevFunc(ReduceScatter_PAT_SIMPLE_MinMax_bf16_0_0_2, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_PAT, NCCL_PROTO_SIMPLE, 0, 0, 2)
DEFINE_ncclDevFunc(ReduceScatter_PAT_SIMPLE_MinMax_bf16_0_1_2, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_PAT, NCCL_PROTO_SIMPLE, 0, 1, 2)
DEFINE_ncclDevFunc(ReduceScatter_RING_LL_MinMax_bf16_0_0_4, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_RING, NCCL_PROTO_LL, 0, 0, 4)
#if (defined(__gfx90a__) || defined(__gfx942__) || defined(__gfx950__)) && defined(ENABLE_LL128)
DEFINE_ncclDevFunc(ReduceScatter_RING_LL128_MinMax_bf16_0_0_4, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_RING, NCCL_PROTO_LL128, 0, 0, 4)
#endif
DEFINE_ncclDevFunc(ReduceScatter_RING_SIMPLE_MinMax_bf16_0_0_4, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_RING, NCCL_PROTO_SIMPLE, 0, 0, 4)
DEFINE_ncclDevFunc(ReduceScatter_RING_SIMPLE_MinMax_bf16_0_1_4, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_RING, NCCL_PROTO_SIMPLE, 0, 1, 4)
DEFINE_ncclDevFunc(ReduceScatter_PAT_LL_MinMax_bf16_0_0_4, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_PAT, NCCL_PROTO_LL, 0, 0, 4)
#if (defined(__gfx90a__) || defined(__gfx942__) || defined(__gfx950__)) && defined(ENABLE_LL128)
DEFINE_ncclDevFunc(ReduceScatter_PAT_LL128_MinMax_bf16_0_0_4, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_PAT, NCCL_PROTO_LL128, 0, 0, 4)
#endif
DEFINE_ncclDevFunc(ReduceScatter_PAT_SIMPLE_MinMax_bf16_0_0_4, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_PAT, NCCL_PROTO_SIMPLE, 0, 0, 4)
DEFINE_ncclDevFunc(ReduceScatter_PAT_SIMPLE_MinMax_bf16_0_1_4, ncclFuncReduceScatter, FuncMinMax, hip_bfloat16, NCCL_ALGO_PAT, NCCL_PROTO_SIMPLE, 0, 1, 4)
